"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const Project_1 = require("./Project");
const TemplateType_1 = require("./TemplateType");
function to(value) { return value; }
class ProjectPathAnalyser {
    constructor(templatePath) {
        // this.project = project;
        this.joinTemplatePath = templatePath;
        this.templatePath = templatePath();
    }
    getProjectFiles(project) {
        const projectFiles = new Project_1.Project(project);
        const allFiles = [];
        // TODO: Files in root/templates
        const rootFiles = this.getDeepFiles(this.templatePath);
        projectFiles.templateFiles = rootFiles;
        // For each source template type
        // const templateTypes = Object.keys(TemplateType);
        // templateTypes.map(t => {
        //   const typ = TemplateType[<any>t];
        //   const files: string[] = [];
        //   // Get the path: root/templates/__typ__/language
        //   const languageDir = this.getPath(typ, project.language);
        //   const templateDir = path.relative(this.templatePath, languageDir);
        //   const f = this.getDeepFiles(languageDir, [typ, project.language].join('\\'));
        //   allFiles.push(...f);
        // });
        return projectFiles;
    }
    // tslint:disable: newline-per-chained-call
    getDeepFiles(dir) {
        const f = this.getFiles(dir);
        const dirs = this.getDirectoryDirectories(dir);
        const dirFiles = dirs.map(d => this.getDeepFiles(path.join(dir, d)));
        const df = dirFiles.length < 1 ? [] : dirFiles.reduce((prev, cur) => prev.concat(cur));
        return f.concat(df);
    }
    getFiles(dir) {
        const files = this.getDirectoryFiles(dir);
        // tslint:disable-next-line: no-unnecessary-local-variable
        const typed = files.map(file => {
            let typ;
            const filePath = path.join(dir, file);
            let relativePath = path.relative(this.templatePath, filePath);
            // TODO: NOT NICE! Refactor!
            // if (/\b__copy__\b/.test(dir)) {
            //   relativePath = relativePath.replace(/\b__copy__\\ts\\\b/g, '');
            //   relativePath = relativePath.replace(/\b__copy__\\\b/g, '');
            //   typ = TemplateType.copyOnly;
            // } else if (/\b__ejs__\b/.test(dir)) {
            //   relativePath = relativePath.replace(/\b__ejs__\\ts\\\b/g, '');
            //   relativePath = relativePath.replace(/\b__ejs__\\\b/g, '');
            //   typ = TemplateType.ejs;
            // } else {
            typ = this.categorizeFile(file);
            // }
            if (typ === TemplateType_1.TemplateType.removeExtension) {
                const newName = path.join(dir, path.basename(file, path.extname(file)));
                relativePath = path.relative(this.templatePath, newName);
            }
            return to({
                // name: file,
                filePath: filePath,
                targetPath: relativePath,
                typ: typ
            });
        });
        return typed;
    }
    getDirectoryDirectories(dir) {
        if (!fs.existsSync(dir)) {
            return [];
        }
        const dirContent = fs.readdirSync(dir);
        return dirContent.filter(f => {
            return fs.lstatSync(path.join(dir, f)).isDirectory();
        });
    }
    getDirectoryFiles(dir) {
        if (!fs.existsSync(dir)) {
            return [];
        }
        const dirContent = fs.readdirSync(dir);
        return dirContent.filter(f => {
            return fs.lstatSync(path.join(dir, f)).isFile();
        });
    }
    // private getPath(typ: string, projectLanguage: string, projectTyp?: string, projectRuntime?: string): string {
    //   let typPrefix = '';
    //   switch (typ) {
    //     case TemplateType.copyOnly:
    //     case TemplateType.ejs:
    //       typPrefix = typ;
    //   }
    //   if (projectRuntime !== undefined) {
    //     return this.joinTemplatePath(typPrefix, projectLanguage, projectTyp, projectRuntime);
    //   } else if (projectTyp !== undefined) {
    //     return this.joinTemplatePath(typPrefix, projectLanguage, projectTyp);
    //   } else if (projectLanguage !== undefined) {
    //     return this.joinTemplatePath(typPrefix, projectLanguage);
    //   } else {
    //     return this.joinTemplatePath(typPrefix);
    //   }
    // }
    categorizeFile(name) {
        if (name.startsWith(TemplateType_1.TemplateType.copyOnly)) {
            return TemplateType_1.TemplateType.copyOnly;
            // } else if (name.startsWith(TemplateType.ejs)) {
            //   return TemplateType.ejs;
            // } else if (name.startsWith(TemplateType.merge)) {
            //   return TemplateType.merge;
            // } else if (path.extname(name) === '.ejs') {
            //   return TemplateType.ejs;
        }
        else if (path.extname(name) === '._') {
            return TemplateType_1.TemplateType.removeExtension;
        }
        else {
            return TemplateType_1.TemplateType.copyOnly;
        }
    }
}
exports.ProjectPathAnalyser = ProjectPathAnalyser;

//# sourceMappingURL=ProjectPathAnalyser.js.map
