import { Answers, ChoiceType } from 'inquirer';
import { IStepQuestion } from './IStepQuestion';
export declare class Question<T> implements IStepQuestion<T> {
    isRequired?: boolean;
    isOption?: boolean;
    description?: string;
    optionType?: BooleanConstructor | StringConstructor | NumberConstructor;
    nextQuestion?: T;
    store?: boolean;
    type?: string;
    name?: string;
    default?: any;
    paginated?: boolean;
    pageSize?: number;
    mask?: string;
    prefix?: string;
    suffix?: string;
    message?: string | ((answers: Answers) => string);
    choices?: ReadonlyArray<ChoiceType> | ((answers: Answers) => ReadonlyArray<ChoiceType>) | ((answers: Answers) => Promise<ReadonlyArray<ChoiceType>>);
    When?: ((answers: Answers) => boolean);
    filter?(input: string): any;
    transformer?(input: string): string;
    validate?(input: any, answers?: Answers): string | boolean | Promise<string | boolean>;
    acceptAnswer?(answer?: string | boolean | number): string | boolean | number | Promise<string | boolean | number>;
    constructor(name: string, props?: Partial<Question<T>>);
    protected setProps(props: Partial<Question<T>>): void;
}
